#ifndef __SOPAD_H
#define __SOPAD_H

/* 225 characters + ending zero */
#define SOPAD_MAX_STRING_LENGTH 256

/* Pad ID Type */
typedef unsigned char SOPAD_PIDType[5];

/* Time stamp (GMT) */
typedef struct
{
	unsigned char years;
	unsigned char months;
	unsigned char days;
	unsigned char hours;
	unsigned char minutes;
	unsigned char seconds;
} SOPAD_GMTStampType;

#pragma pack(push, 4)

typedef struct
{
	short x;
	short y;
	unsigned char z;
	int FrameNumber;
	unsigned char LineNumber;
	int timecode;
} SOPAD_TDataFrame;

#pragma pack(pop)

#ifdef __cplusplus
extern "C" {
#endif

BOOL SOPAD_Initialize();
void SOPAD_Uninitialize();

void SOPAD_getPadSettings(const char* szOldSettings, const char* szCertStr,
						  char szNewSettings[SOPAD_MAX_STRING_LENGTH]);
void SOPAD_setPadSettings(const char* szPadSettings, const char* szCertStr);
void SOPAD_checkCom(unsigned char nComPort, char szPadType[SOPAD_MAX_STRING_LENGTH]);
void SOPAD_setCom(unsigned char nComPort);
void SOPAD_setPadType(const char* szPadType);
void SOPAD_getPID(SOPAD_PIDType pPadID, const char* szCertStr);
void SOPAD_setPID(const SOPAD_PIDType pPadID, const char* szCertStr);
void SOPAD_startRead();
void SOPAD_stopRead(SOPAD_PIDType pPadID, SOPAD_GMTStampType* pTimeStamp);
void SOPAD_clearBioData();
BOOL SOPAD_framesAvailable();
void SOPAD_getFrame(SOPAD_TDataFrame* pFrame);
void SOPAD_registerCanvas(void* pCanvas, int xoffs, int yoffs, int width, int height);
void SOPAD_unRegisterCanvas();
void SOPAD_setLang(const char* szLang);

#ifdef __cplusplus
}
#endif

#endif	// __SOPAD_H