//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "SOPad.c"
#include "SOPad.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
char* globCertStr;
char settings[SOPAD_MAX_STRING_LENGTH];
char padType1[SOPAD_MAX_STRING_LENGTH];
SOPAD_GMTStampType Timestamp; // Define variable
SOPAD_PIDType globPID; // Define variable
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LibLoadClick(TObject *Sender)
{
 if (SOPAD_Initialize()==False)  // Load the dll
   LibLoad->Caption="Error loading lib";
   else
   LibLoad->Caption="Lib loaded";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UnloadLibClick(TObject *Sender)
{
SOPAD_Uninitialize();  // Unload the dll
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GetPadClick(TObject *Sender)
{
SOPAD_getPadSettings("",globCertStr,settings); // Get the Padsettings from the driver
Label1->Caption=settings; // Display the actual settings
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetPadClick(TObject *Sender)
{       // Give the pad settings to the driver
SOPAD_setPadSettings(settings,globCertStr);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RegisterCanvClick(TObject *Sender)
{        // Register the canvas object to draw the signature
SOPAD_registerCanvas(Image1->Canvas,0,0,Image1->Width,Image1->Height);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StartreadClick(TObject *Sender)
{
SOPAD_startRead(); // Call start read (open com port)
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StopreadClick(TObject *Sender)
{
SOPAD_stopRead(globPID,&Timestamp); // Call stop read (clos port and get PID an GMT Stamp)
Label4->Caption=StrToInt(AnsiString(globPID[0])); // Display Pad ID
Label4->Caption=Label4->Caption+"-"+StrToInt(AnsiString(globPID[1]));
Label4->Caption=Label4->Caption+"-"+StrToInt(AnsiString(globPID[2]));
Label4->Caption=Label4->Caption+"-"+StrToInt(AnsiString(globPID[3]));
Label4->Caption=Label4->Caption+"-"+StrToInt(AnsiString(globPID[4]));
Label5->Caption=StrToInt(AnsiString(Timestamp.days)); // Display Timestamp (GMT)
Label5->Caption=Label5->Caption+"."+StrToInt(AnsiString(Timestamp.months));
Label5->Caption=Label5->Caption+"."+StrToInt(AnsiString(Timestamp.years));
Label5->Caption=Label5->Caption+" "+StrToInt(AnsiString(Timestamp.hours));
Label5->Caption=Label5->Caption+":"+StrToInt(AnsiString(Timestamp.minutes));
Label5->Caption=Label5->Caption+":"+StrToInt(AnsiString(Timestamp.seconds))+"h";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
SOPAD_unRegisterCanvas(); // Unregister the canvas object to draw to
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetLanguageClick(TObject *Sender)
{    // Set the language
char* Lang;
Lang="GB";  // Default english
if (ComboBox1->Text=="D")
        Lang="D";
if (ComboBox1->Text=="PL")
        Lang="PL";
if (ComboBox1->Text=="ES")
        Lang="ES";
//Lang=ComboBox1->Text;
SOPAD_setLang(Lang);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetComClick(TObject *Sender)
{
SOPAD_setCom(StrToInt(ComboBox2->Text));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckPadClick(TObject *Sender)
{
SOPAD_checkCom(StrToInt(ComboBox3->Text),padType1);
Label25->Caption=padType1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::GetPadIDClick(TObject *Sender)
{
SOPAD_getPID(globPID,globCertStr);
Label26->Caption=StrToInt(AnsiString(globPID[0])); // Display Pad ID
Label26->Caption=Label26->Caption+"-"+StrToInt(AnsiString(globPID[1]));
Label26->Caption=Label26->Caption+"-"+StrToInt(AnsiString(globPID[2]));
Label26->Caption=Label26->Caption+"-"+StrToInt(AnsiString(globPID[3]));
Label26->Caption=Label26->Caption+"-"+StrToInt(AnsiString(globPID[4]));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox2Change(TObject *Sender)
{
ComboBox3->ItemIndex=ComboBox2->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetPadTypeClick(TObject *Sender)
{
SOPAD_setPadType(padType1);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetPadIDClick(TObject *Sender)
{
SOPAD_setPID(globPID,globCertStr);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
if (CheckBox1->Checked)
        globCertStr="109142127193StepOver Demo DEV Software";
        else
        globCertStr="";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
CheckBox1Click(Sender);
}
//---------------------------------------------------------------------------



void __fastcall TForm1::GetBioDataClick(TObject *Sender)
{
AnsiString aString;
SOPAD_TDataFrame bioFrame;
aString="";
while (SOPAD_framesAvailable()) { // First we read all biodata and add them to a string
        SOPAD_getFrame(&bioFrame);
        aString=aString+("x"+IntToStr(bioFrame.x)
                +"y"+IntToStr(bioFrame.y)+"z"+IntToStr(bioFrame.z)
                +"f"+IntToStr(bioFrame.FrameNumber)+"l"+
                IntToStr(bioFrame.LineNumber)+"t"+IntToStr(bioFrame.timecode));
        }  // Afterwards we take the PID and Timestamp from Stopread and add them
           // to the string. This string is now identical with a biodatastring from
           // the Active X Control interface. We recommand that you store your biodta
           // in a string that way. This makes it easyer to handle the biodta
           // to a verification engine if you need to do that later.
        aString=aString+("p"+AnsiString(globPID[0])+"-"+AnsiString(globPID[1])+"-"+
                   AnsiString(globPID[2])+"-"+AnsiString(globPID[3])+"-"+
                   AnsiString(globPID[4])+"g"+AnsiString(Timestamp.hours)+":"+
                   AnsiString(Timestamp.minutes)+":"+AnsiString(Timestamp.seconds)+
                   " "+AnsiString(Timestamp.days)+"."+AnsiString(Timestamp.months)+
                   "."+AnsiString(Timestamp.years));
Memo1->Lines->Add(aString);
// After this function all biodta are deleted in the driver. 
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClearBioDataClick(TObject *Sender)
{
SOPAD_clearBioData();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClearClick(TObject *Sender)
{
Image1->Canvas->FillRect(Image1->ClientRect);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::clearMemoClick(TObject *Sender)
{
Memo1->Clear();
}
//---------------------------------------------------------------------------

