unit ExampUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, SyncObjs, StrUtils;

type
  TportList=array[1..256] of shortstring;

  PIDType = array[1..5] of Byte;

  PDataFrame = ^TDataFrame;
  TDataFrame = record
      x,
      y : SmallInt;
      z : Byte;
      FrameNumber : integer;
      LineNumber : Byte;
      timeCode : integer;
  end;

  tFrames= Array of tdataFrame;

  GMTStampType = record
      years : byte;
      months : byte;
      days : byte;
      hours : byte;
      minutes : byte;
      seconds : byte;
  end;


  // Zum Testen
  TPollThread = class(TThread)
  private
      Frame: TDataFrame;
      Memo : TMemo;
      procedure ShowFrame;
  protected
      procedure Execute; override;
  public
      constructor Create(Memo : TMemo);
  end;


  TForm1 = class( TForm )
      OpenPortButton: TSpeedButton;
      ClosePortButton: TSpeedButton;
      ClearImage1Button: TButton;
      GetBIODataButton: TButton;
      UnRegisterCanvasButton: TButton;
      RegisterImage2Button: TButton;
      RegisterImage1Button: TButton;
      StartPollingButton: TButton;
      StopPollingButton: TButton;
      Memo: TMemo;
      Image1: TImage;
      Image2: TImage;
      Bevel2: TBevel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    Button4: TButton;
    GroupBox1: TGroupBox;
    cbPorts: TComboBox;
    StaticText1: TStaticText;
    GetPIDButton: TButton;
    SetPIDButton: TButton;
    CheckPortButton: TButton;
    Label2: TLabel;
    Button5: TButton;
    Button6: TButton;
    memo1: TMemo;
    ComboBox1: TComboBox;
    Label3: TLabel;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Label4: TLabel;
    Timer1: TTimer;
    Timer2: TTimer;

      procedure btnOpenClick( Sender: TObject );
      procedure btnCloseClick( Sender: TObject );

      procedure FormCreate( Sender: TObject );
      procedure FormDestroy( Sender: TObject );

      procedure ClearImage1ButtonClick(Sender: TObject);
      procedure GetPIDClick(Sender: TObject);
      procedure SetPIDClick(Sender: TObject);
      procedure GetBIODataButtonClick(Sender: TObject);
      procedure CheckPortButtonClick(Sender: TObject);
      procedure UnRegisterCanvasButtonClick(Sender: TObject);
      procedure RegisterImage2ButtonClick(Sender: TObject);
      procedure RegisterImage1ButtonClick(Sender: TObject);
      procedure StartPollingButtonClick(Sender: TObject);
      procedure StopPollingButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure cbPortsChange(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
      PollThread : TPollThread;
  end;


var
  Form1 : TForm1;
  oldwinX,oldwinY:integer;

  procedure enumPorts(var PortList: TPortlist); external 'SOPad.dll';
  procedure setCom(Com: Byte); external 'SOPad.dll';
  procedure startRead(); external 'SOPad.dll';
  procedure clearBioData; external 'SOPad.dll';
  procedure checkCom(Com : Byte; var PadType : shortstring); external 'SOPad.dll';
  procedure getPID(var PadID: PIDType; CertStr:shortstring); external 'SOPad.dll';
  procedure setPID(PadID: PIDType; CertStr:shortstring); external 'SOPad.dll';
  procedure setPadType(PadType: shortstring); external 'SOPad.dll';
  function framesAvailable  : Boolean; external 'SOPad.dll';
  procedure getFrame(var Frame: TDataFrame); external 'SOPad.dll';
  procedure stopRead(var PadID: PIDType; var TimeStamp : GMTStampType); external 'SOPad.dll';
  procedure getBioData(var PadID : PIDType; var GMTS : GMTStampType;
                      var nFrames : integer; var Data: tframes); external 'SOPad.dll';
  procedure unRegisterCanvas; external 'SOPad.dll';
  procedure registerCanvas(canvas : TCanvas; xoffs, yoffs, width, height : Integer); external 'SOPad.dll';
  Function getPadSettings(oldSettings,certStr:shortstring):shortstring; external 'SOPad.dll';
  procedure setPadSettings(padSetting, certStr:shortstring); external 'SOPad.dll';
  procedure setLang(lang:shortstring); external 'SOPad.dll';
  Procedure useWintabDevices(TabletPC,ExternalDevices:Boolean); external 'SOPad.dll';
  Procedure setWintabTabletPCRegion(x1,y1,x2,y2:Integer); external 'SOPad.dll';
 { function getBioDataString:Pchar; external 'SOPad.dll';
  procedure deCompBioDataString(Biodata:Pchar); external 'SOPad.dll';
  Procedure addMD5(Sourcefile,destFile:Pchar); external 'SOPad.dll';   }

implementation
   var
   p : PIDType;
   Cert:shortstring;
  {$R *.DFM}

  procedure TPollThread.ShowFrame;
  begin
      with Frame do
      begin
         Memo.Lines.Add('x=' + inttostr(x) + ' y=' + inttostr(y)
              +' z=' + inttostr(z) + ' fn=' + inttostr(FrameNumber)
              + ' ln=' + inttostr(LineNumber)+ ' time=' + inttostr(timecode));
      end;
  end;


  procedure TPollThread.Execute;
  var Delay : TEvent;
  begin
      Delay := TEvent.Create(nil, true, false, '');
      repeat
          while not FramesAvailable and not Terminated do
              Delay.WaitFor(40);
          if FramesAvailable then
          begin
              GetFrame(Frame);
              synchronize(ShowFrame);
          end;
      until Terminated;
  end;


  constructor TPollThread.Create(Memo : TMemo);
  begin
      self.Memo := Memo;
      inherited Create(false);
  end;


  procedure TForm1.CheckPortButtonClick(Sender: TObject);
  var com : Integer;
      p : shortstring;
  begin
      com := strtoint(cbPorts.Items[cbPorts.ItemIndex]);
      CheckCom(com, p);
      Memo.Lines.Add('Padtype on com' + inttostr(com) + ': ' + p);
  end;


  procedure TForm1.GetBIODataButtonClick(Sender: TObject);
  var Data : tframes;
      nsa : Integer;
      pid : PIDType;
      i : Integer;
      pf : PDataFrame;
      gmts : GMTStampType;
  begin
      GetBioData(pid, gmts, nsa, Data);

      for i := 0 to length(data)-1 do
      begin
         { pf := PDataFrame(Data + i * sizeof(TDataFrame));
          with pf^ do
          begin    }
              Memo.Lines.Add('x=' + inttostr(data[i].x) + ' y=' + inttostr(data[i].y)
              +' z=' + inttostr(data[i].z) + ' fn=' + inttostr(data[i].FrameNumber)
              + ' ln=' + inttostr(data[i].LineNumber)+ ' time=' + inttostr(data[i].timecode));

          //end;
      end;

      application.ProcessMessages;

      Memo.Lines.Add('process id: '+inttostr(pid[1]) + '-' +inttostr(pid[2]) + '-' +inttostr(pid[3]) + '-' +inttostr(pid[4]) + '-' +inttostr(pid[5]));
      Memo.Lines.Add(inttostr(gmts.hours)+':'+inttostr(gmts.minutes)+':'+inttostr(gmts.seconds)
          +' '+ inttostr(gmts.days)+'.'+inttostr(gmts.months)+'.'+inttostr(gmts.years));

      //ClearBioData;
  end;


  procedure TForm1.GetPIDClick( Sender: TObject );
  var i : Integer;
  begin
      GetPID(p,Cert);
      for i:=1 to 5 do Memo.Lines.Add('PID:'+ IntToStr(p[i]));
  end;


  procedure TForm1.SetPIDClick(Sender: TObject);
  var ID : PIDType;
  begin
      // put the values here that you get with GetPID
      ID[1] := 84;
      ID[2] := 108;
      ID[3] := 13;
      ID[4] := 58;
      ID[5] := 100;
      SetPID(p,Cert);
  end;


  procedure TForm1.FormCreate( Sender: TObject );
  var
  i:integer;
  PoList:tPortlist;
  begin
       EnumPorts(polist);
        for i:=1 to 256 do
        begin
        IF polist[i]<>'0' then
                cbPorts.Items.Add(PoList[i])
                else
                break;
        end;
       if cbPorts.Items.Count > 0 then
           cbPorts.ItemIndex := 0; // show first available port
       RegisterCanvas(Image1.Canvas, 0, 0, Image1.ClientWidth , Image1.ClientHeight);
       cbPortsChange(sender);
  end;


  procedure TForm1.FormDestroy( Sender: TObject );
  var
      PadID: PIDType;
      TimeStamp : GMTStampType;
  begin
      cbPorts.Destroy;
      StopRead(PadID, TimeStamp);
  end;


  procedure TForm1.btnOpenClick( Sender: TObject );
  begin
      cbPorts.Enabled := false;
      setWintabTabletPCRegion(image1.ClientOrigin.X,image1.ClientOrigin.y,
              image1.ClientOrigin.X+image1.Width,image1.ClientOrigin.y+image1.Height);
      StartRead();
  end;


  procedure TForm1.btnCloseClick( Sender: TObject );
  var
      PadID: PIDType;
      TimeStamp : GMTStampType;
  begin
      StopRead(PadID, TimeStamp);
      cbPorts.Enabled := true;
  end;


  procedure TForm1.ClearImage1ButtonClick(Sender: TObject);
  begin
      Image1.Canvas.FillRect(Image1.ClientRect);
  end;


  procedure TForm1.UnRegisterCanvasButtonClick(Sender: TObject);
  begin
      UnRegisterCanvas;
  end;


  procedure TForm1.RegisterImage2ButtonClick(Sender: TObject);
  begin
      RegisterCanvas(Image2.Canvas, 0, 0, Image2.ClientWidth , Image2.ClientHeight);
  end;


  procedure TForm1.RegisterImage1ButtonClick(Sender: TObject);
  begin
      RegisterCanvas(Image1.Canvas, 0, 0, Image1.ClientWidth , Image1.ClientHeight);
  end;


  procedure TForm1.StartPollingButtonClick(Sender: TObject);
  begin
      PollThread := TPollThread.Create(Memo);
  end;


  procedure TForm1.StopPollingButtonClick(Sender: TObject);
  begin
      if Assigned(PollThread) then PollThread.Terminate;
  end;

procedure TForm1.Button1Click(Sender: TObject);
begin
useWintabDevices(checkbox2.Checked,checkbox3.Checked);
Label2.Caption:=getPadSettings(Label2.Caption,Cert);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
clearBioData;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
image1.Picture.SaveToFile('C:\test.bmp');
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
If Checkbox1.Checked then
        begin
        Cert:=pchar('109142127193StepOver Demo DEV Software');
        end
        else
        Cert:=pchar('');
end;

procedure TForm1.cbPortsChange(Sender: TObject);
begin
SetCom(strtoint(cbPorts.Items[cbPorts.ItemIndex]));
end;

procedure TForm1.Button4Click(Sender: TObject);
var
sett:shortstring;
begin
Sett:=Label2.caption;
SetPadSettings(Sett,cert);
end;

procedure TForm1.Button5Click(Sender: TObject);
var
Pf:Pchar;
sdtr:string;
begin
//pf:=GetBioDataString;
//setstring(sdtr,pf,length(pf));
memo1.Lines.Add(pf);
end;

procedure TForm1.Button6Click(Sender: TObject);
var
Pf:Pchar;
begin
//
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
setlang(combobox1.Text);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
Label4.Caption:='X:'+inttostr(image1.ClientOrigin.X)+' Y:'+inttostr(image1.ClientOrigin.Y);
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
IF (oldwinX<> image1.ClientOrigin.X) or  (oldwinY<>image1.ClientOrigin.y) then
        begin
        oldwinX:=image1.ClientOrigin.X;
        oldwinY:=image1.ClientOrigin.y;
        setWintabTabletPCRegion(image1.ClientOrigin.X,image1.ClientOrigin.y,
                        image1.ClientOrigin.X+image1.Width,image1.ClientOrigin.y+image1.Height);
        end;
end;

end.
