unit paddll;

interface

 uses
  SysUtils,
  Classes,
  SyncObjs,
  Comport,
  Messages,
  Windows,
  Graphics,
  configwin,
  vars,
  Dialogs,
  VaClasses,
  VaComm,
  VaPrst,
  wintab,
  Tablet,
  WintabConsts,
  DCPcrypt2, DCPblockciphers, DCPblowfish,
  DCPsha1,timework,Registry,fileworks,silentregist;
  
const

  waitbeforeupdatems = 50;


  lcPktData = PK_CURSOR or PK_BUTTONS or PK_X or PK_Y or PK_NORMAL_PRESSURE or PK_ORIENTATION;
  lcOptions = {CXO_SYSTEM or // IF this is blue wintab will not use the mousecursor} CXO_MESSAGES or CXO_CSRMESSAGES;
  lcTabletOptions = CXO_SYSTEM or CXO_MESSAGES or CXO_CSRMESSAGES;
  lcBtnMask = SBN_LCLICK or SBN_RCLICK or SBN_LDBLCLICK or SBN_RDBLCLICK;

  type
  //TportList=array[1..256] of shortstring;
  Tstartmeup = function (Language,corpcode,prodnum:shortstring;var Password:Shortstring):shortstring;
  Wrapper2 = class(TComponent)
          Procedure Tablet1Packet(Sender: TObject; PacketNumber, ContextHandle: HCtx;
                     pPacket: Pointer);
          public
          { Public declarations }
          constructor Create( AOwner: TComponent ); override;
  end;

  TUpdateManager = class(TThread)
  public
     Trigger : TEvent;
  private
     Delay : TEvent;
     originalonchange : TNotifyEvent;
  protected
      procedure Execute; override;
      procedure RegisterOnChange(oc : TNotifyEvent);
      constructor Create;
  end;



  Wrapper = class(TComponent)
       procedure ComPort1ReceiveCallBack( Data: string );
       procedure OnChange(Sender: TObject);
       procedure RegisterCanvas(c : TCanvas);
       procedure UnRegisterCanvas;

       procedure VaComm1RxChar(Sender: TObject; Count: Integer);

  private
      UpdateManager : TUpdateManager;
      mycanvas : TCanvas;
      originalonchange : TNotifyEvent;
  public
      { Public declarations }
      constructor Create( AOwner: TComponent ); override;
  end;


Procedure setLang(lang:shortstring);
procedure enumPorts(var PortList: TPortlist);
procedure SetCom(Com: Byte);
procedure StartRead();
procedure ClearBioData;
procedure CheckCom(Com : Byte; var PadTyp : shortstring); //changed
function GetPID(var PadID: PIDType;certStr:shortstring):Boolean;
function GetPIDold(var PadID: PIDType):Boolean;
procedure SetPID(PadID: PIDType;CertStr:shortstring);
procedure SetPadType(PadType: shortstring); //changed
function FramesAvailable : Boolean;
procedure GetFrame(var Frame: TDataFrame);
procedure StopRead(var PadID: PIDType; var TimeStamp : GMTStampType);
procedure GetBioData(var PadID : PIDType; var GMTS : GMTStampType;
                     var nFrames : integer; var Data:TFrames);  //Changed
//function getBioDataString:Pchar;
//procedure deCompBioDataString(Biodata:Pchar);
procedure UnRegisterCanvas;
procedure RegisterCanvas(canvas : TCanvas; xoffs, yoffs, width, height : Integer);
function getPadSettings(oldSettings,CertStr:shortstring):shortstring;
procedure setPadSettings(PadSettings,CertStr:shortstring);
function startWintab:string;
procedure closeWintab;
Procedure useWintabDevices(TabletPC,ExternalDevices:Boolean);
Procedure setWintabCorpLic(corpLic:shortstring);
Procedure setWintabTabletPCRegion(x1,y1,x2,y2:Integer);
function startCapture(Certificate:shortstring):Boolean;
function configurePad(Certificate:shortstring):Boolean;
function tabletTurned:boolean;
function WintabActivation:boolean;

var
pWait,PadIDstr,tryuse,CerApp,ReqID,fiveSec,warni,warning1,uncert,
congrad1,congrad2:string;
globLanguage,globcorpcode,globprodnum,globlicence,globactualPad,globAutosearch,
globMansearch:string;
Tablet1: TTablet;
w2 : Wrapper2;
Tabletframenumber,tablettime,tabletxres,tabletyres,tabletsamplerate,
xmin,xmax,ymin,ymax,tabletminx,tabletminy,tabletmsec,tabletpcyres,
tabletpcxres,tabletMaximumX,tabletMaximumY,OTabletX1,OTabletY1,OTabletX2,
OTabletY2,OldXMax,OldYMax:Integer;
Tabletlinenumber,Tabletoldlinenumber,wintabPidval:Byte;
TabletReadTime,tablettimego,tabletclosed:Boolean;
factX,factY,factZ,tabletPCDivX,tabletPCDivY:double;

implementation

uses
PADID,Warn,Controls;

var
tcs : TCriticalSection;


  w : Wrapper;

  // For buffering serial data
  DataBuffer : String;

  // The Com Port
  ComPortNr : byte;

  // The PID that is used for decryption
  PID : PIDType;

  // whether or not the pid is a valid pid that was read from the pad
  PIDValid : boolean;

  ReceivedPID : TEvent;
  ReceivedPadType : TEvent;

  isLE : Boolean = false;

  BioData : TBioData;

  // index of the next BioData.Frames entry that GetFrame is going to return
  FrameIndex : Integer;

  BufferAll : Boolean = False;

  BData : PChar;
  BDataSize : Integer = 0;

  ComPort1: TComPort;
  VaComm1: TVaComm;

  numgoodframes, numallframes, oldlinenumber : Integer;
  firsttime : Boolean;

  xpos, ypos : single;

  dd : Integer;
  Firstread:Boolean;
  fIndex,ftime,lOld,fnowold,fn,fnold:integer;


  outputCanvas : TCanvas = nil;
  xoffset, yoffset, desiredwidth, desiredheight: Integer;

  procedure TUpdateManager.Execute;
  var temp_originalonchange : TNotifyEvent;
  begin
      repeat
          // OnChange from the other thread triggers this
          Trigger.WaitFor(INFINITE);
          Trigger.ResetEvent;

          // call the original OnChange
          temp_originalonchange := originalonchange;
          if Assigned(temp_originalonchange) then
          begin
              tcs.Acquire;
              temp_originalonchange(nil);
              tcs.Release;
          end;

          // wait for a given time, so subsequent
          // OnChange events can be handled together
          Delay.WaitFor(waitbeforeupdatems);
      until false;
  end;

  constructor TUpdateManager.Create;
  begin
      Trigger := TEvent.Create(nil, true, false, '');
      Delay := TEvent.Create(nil, true, false, '');
      inherited Create(false);
  end;

  procedure TUpdateManager.RegisterOnChange(oc : TNotifyEvent);
  begin
      originalonchange := oc;
  end;


  procedure Wrapper.RegisterCanvas(c : TCanvas);
  begin
      mycanvas := c;

      originalonchange := c.OnChange;
      c.OnChange := self.OnChange;

      UpdateManager.RegisterOnChange(originalonchange);
  end;

  procedure Wrapper.UnRegisterCanvas;
  begin
      mycanvas.OnChange := originalonchange;
      UpdateManager.RegisterOnChange(nil);
  end;

  procedure Wrapper.OnChange(Sender: TObject);
  begin
      UpdateManager.Trigger.SetEvent;
  end;

  Procedure CloseP;
  var
  delay:TEvent;
  star:string;
  begin

  VaComm1.SetDTR(false);
  VaComm1.SetRTS(false);

  VaComm1.FlowControl.ControlDtr:=dtrDisabled;
  VaComm1.FlowControl.ControlRts:=rtsDisabled;

  //  ComPort1.SetRTS(false);
//  ComPort1.SetDTR(false);
  Delay := TEvent.Create(nil, true, false, '');
  Delay.WaitFor(200);
  Delay.Destroy;
  Star := '*';
  VaComm1.WriteBuf(Star, 1);
  Delay := TEvent.Create(nil, true, false, '');
  Delay.WaitFor(200);
  Delay.Destroy;
//  ComPort1.Close;

  VaComm1.Close;


  end;

function decryptpw(data:string):string;
var
Cipher: TDCP_blowfish;
begin
        Cipher:= TDCP_blowfish.Create(nil);
        cipher.CipherMode:=cmCBC;
        try
                Cipher.InitStr('StepOverHelpworkshop1119',TDCP_sha1);
                result:=Cipher.decryptString(Data);
        except
                MessageDlg('Decryption Error',mtError,[mbOK],0);
        end;
        Cipher.Burn;
        Cipher.Free;
end;

function validEngine(oldPW,newPW:string):wordbool;
begin
result:=((oldPW<>newpw) and (decryptpw(newpw)=oldpw));
end;

function WintabActivation:boolean;
begin
globprodnum:='005';
result:=silentregist.CheckLic(globCorpCode,globLanguage,globprodnum,'SignaturePadDriver','Pad Driver Wintab extension');
end;

  // AnsiContainsStr didn't work for some strange reason
  // probably irritated by #0 characters... so DIY
  function containsstr(AText, ASubText : String) : Boolean; // export;
  var i, j, atlen, astlen : Integer;
      c : Boolean;
  begin
      c := true;
      atlen := length(AText);
      astlen := length(ASubText);
      if (atlen < astlen) then
      begin
          c := false;
      end else
      begin
          for i:=1 to atlen-astlen+1 do
          begin
              c := true;
              for j:=0 to astlen-1 do
              begin
                  if AText[i+j] <> ASubText[j+1] then
                  begin
                      c := false;
                      break;
                  end;
              end;
              if c then break;
          end;
      end;
      containsstr := c;
  end;


  procedure EnumPorts(var PortList: TPortlist); //export;
  var
  i:integer;
  begin
  for i:=1 to 256 do
        begin
        Portlist[i]:='0';
        end;
  EnumPortsNumberOnly(PortList);
  end;


  procedure SetCom(Com: Byte); //export;
  begin
      wintabPidval:=com;
      ComPortNr := Com;
  end;


  procedure StartRead(); //export;
  var PortName, Star: String;
      i : Integer;
  begin
  Firstread:=true;

  oldlinenumber:=0;

  numgoodframes:=0; //Checksum OK
  DataBuffer := ''; // Initialize DataBuffer;
  PIDValid := false;
  for i := 1 to 5 do PID[i] := 0; // Initialize IDNumber
  numallframes:=0; // Header found
  IF ansilowercase(copy(globPadType,1,6))<>'wintab' then
      begin
      xmin := 140 - 100;
      xmax := 3740 + 300;
      ymin := 1010 - 200;
      ymax := 3100 + 200;
      ReceivedPID := TEvent.Create(nil, true, false, '');

      ReceivedPadType := TEvent.Create(nil, true, false, '');

      //globPadType:='';
      ReceivedPadType.ResetEvent;

      if ComPortNr > 9 then
          PortName := '\\.\COM' + IntToStr( ComPortNr ) // ask Microsoft why...
      else
          PortName := 'COM' + IntToStr( ComPortNr );



      VaComm1.DeviceName := PortName;

      // Stromversorgung einschalten
      // VaComm1.DTRControl := dtrEnable;



      VaComm1.Open;

      //VaComm1.SetDTR(true);
      //VaComm1.SetRTS(true);
      VaComm1.FlowControl.ControlDtr:=dtrEnabled;
      VaComm1.FlowControl.ControlRts:=rtsEnabled;
      {VaComm1.rRTSControl := rtsEnable;
      VaComm1.DTREnable := dtrEnable;   }
      // Damit eine evtl. vorhandene Bluetooth - Brcke initialisiert wird
      //ComPort1.Send('*');
      Star := '*';
      VaComm1.WriteBuf(Star, 1);


{
      ComPort1.Port := PortName;
      ComPort1.Open;

      // Stromversorgung einschalten
      ComPort1.SetRTS(true);
      ComPort1.SetDTR(true);
      // Damit eine evtl. vorhandene Bluetooth - Brcke initialisiert wird
      ComPort1.Send('*');
 }
      //BioData.Frames := TList.Create;
      FrameIndex := 0;
      If globauto and ((globPID[1]+globPID[2]+globPID[3]+globPID[4]+globPID[5])<>0)then
        begin
        setPID(globPID,globCert);
        globAuto:=true;
        end;
      end
      else
      begin
      xmin := 0;
      xmax := 3740 + 300;
      ymin := 0;
      ymax := 3100 + 200;
      startWintab;
      end;

  end;

  procedure ClearBioData; //export;
  var i : Integer;
      pf : PDataFrame;
      clearframe : TDataFrame;
  begin
      for I := 0 to length(Biodata.frames)-1 do
        begin
        Biodata.frames[I] := clearframe;
        end;
     { for i := 0 to BDataSize - 1 do
          (BData + i)^ := char(0);

      If BDataSize>0 then // Freemem crashes if BDataSize is <1 ask Bill Why!
         FreeMem(BData, BDataSize);      }

     Biodata.Frames:=Nil;

      BDataSize := 0;

    {  for i := 0 to BioData.Frames.Count - 1  do
      begin
          pf := PDataFrame(BioData.Frames.Items[i]);
          pf^ := clearframe; // overwrite the frame data
          dispose(pf);
      end;       }

      FrameIndex := 0;

    {  BioData.Frames.Clear;  }

      for i:=1 to 5 do BioData.PID[i] := 0;

      with BioData.GMTStamp do
      begin
          seconds := 0;
          minutes := 0;
          hours := 0;
          days := 0;
          months := 0;
          years := 0;
      end;
  end;


  procedure CheckCom(Com : Byte; var PadTyp :shortstring); //export;
  var Delay : TEvent;
      WasAuto:Boolean;
      oldtick:Cardinal;
  begin
      WasAuto:=globAuto;
      globauto:=False;
      SetCom(Com);
      globPadType:='';
      BufferAll := true;
      StartRead();

      if ReceivedPadType.WaitFor(7000) = wrSignaled then
      begin

          // wait an additional 200 ms, to see if we received
          // an ID+GMT frame with the timestamp consisting of only 7fs
          // according to Bernhard this means we got an LE-Pad

          Delay := TEvent.Create(nil, true, false, '');
          Delay.WaitFor(200);
          Delay.Destroy;

          if isLE then
          begin
              // change + to LE
              if globPadType = '+Pad BT'  then globPadType := 'LE Pad BT';
              if globPadType = '+Pad USB' then globPadType := 'LE Pad USB';
              if globPadType = '+Pad SP'   then globPadType := 'LE Pad SP';
          end;

          // either we received a String identifying the type of pad,
          // or we didn't and the first firmware version frames came in,
          // so we know it's a bluepad
          if globPadType = '' then globPadType := 'blueMPad / bluePad';
      end else
      begin // time out, no pad type, no firmware version frames received -> no pad detected
          globPadType := 'no pad';
      end;

      PadTyp := Pchar(globPadType);

      CloseP();

      ClearBioData;

      globAuto:=WasAuto;
  end;

  function GetPID(var PadID: PIDType;certStr:shortstring):Boolean;
  begin
  globCert:=certStr;
  globPID[1]:=0;
  globPID[2]:=0;
  globPID[3]:=0;
  globPID[4]:=0;
  globPID[5]:=0;
  Form2:=TForm2.Create(nil);
  result:=Form2.ShowModal=mrOK;
  PADID:=GlobPid;
 { if not globAuto then
        globCert:='';       }
  end;

  function GetPIDold(var PadID: PIDType):Boolean; //export;
  begin
      Result:=False;
      ReceivedPID.ResetEvent; { Ereignis vor der Ausfhrung der Threads zurcksetzen }
      if (PIDValid) then PadID := PID
      else
      begin
          ReceivedPID.WaitFor(2000);
          if (PIDValid) then
                begin
                PadID := PID;
                result:=true;
                end;
          // Memo2.Lines.Add('TForm1.GetPID(var PadID: PIDType); finished');
      end;
      //CloseP();
      ClearBioData;
  end;


  procedure SetPID(PadID: PIDType;CertStr:shortstring); //export;
  var
  proceed:boolean;
  begin
  Proceed:=true;
  If not form2.Checkcert(CertStr) then
      begin
      proceed:=False;
      Warning:=TWarning.Create(nil);
      If Warning.ShowModal=mrok then
        begin
        proceed:=True;
        end;
      end;
  If proceed then
        begin
        PIDValid := false; // damit ein nachfolgender aufruf von GetPID die Hardware abfragt
        PID := PadID;
        globPID:=PID;
        globauto:=False;
        end
        else
        begin
        PIDValid := false; // damit ein nachfolgender aufruf von GetPID die Hardware abfragt
        PID[1]:=1;
        PID[2]:=0;
        PID[3]:=0;
        PID[4]:=0;
        PID[5]:=0;
        globauto:=False;
        end;
  end;


  procedure SetPadType(PadType: shortstring); //export;
  var
  str:string;
  begin
      str:=PadType;
      globPadType:=copy(str,1,length(str));
  end;



  function FramesAvailable : Boolean; //export;
  begin
      FramesAvailable := FrameIndex < length(BioData.Frames);
  end;


  procedure GetFrame(var Frame: TDataFrame); //export;
  begin
      if FramesAvailable then
      begin
          Frame := (BioData.Frames[FrameIndex]);
          Inc(FrameIndex);
      end;
  end;


  procedure StopRead(var PadID: PIDType; var TimeStamp : GMTStampType); //export;
  begin
  IF ansilowercase(copy(globPadType,1,6))<>'wintab' then
      begin
      CloseP();
      end
      else
      closewintab;
  PadID := BioData.PID;
  TimeStamp := BioData.GMTStamp;
  end;

  // after execution Data points to a sequence of TFrames
  procedure GetBioData(var PadID : PIDType; var GMTS : GMTStampType; var nFrames : integer; var Data: TFrames); //export;
  var NumOfSamples : Integer;
      i : Integer;
      pf : PDataFrame;
  begin
      PadID := BioData.PID;
      GMTS := BioData.GMTStamp;
      //BioData.Frames.Pack;
      NumOfSamples := length(BioData.Frames);
      nFrames := NumOfSamples;
      BDataSize := SizeOf(TDataFrame) * NumOfSamples;
      {BData := AllocMem(BDataSize);
      for i := 0 to NumOfSamples - 1 do
      begin
          pf := PDataFrame(BData + i * sizeof(TDataFrame));
          pf^ := (PDataFrame(BioData.Frames.Items[i]))^;
      end;
      Data := BData;    }
      Data:= Biodata.frames;
  end;


  procedure UnRegisterCanvas; //export;
  begin
      xoffset := 0;
      yoffset := 0;
      desiredwidth := 100;
      desiredheight := 100;
      outputCanvas := nil;

      w.UnRegisterCanvas;
  end;


  procedure RegisterCanvas(canvas : TCanvas; xoffs, yoffs, width, height : Integer); //export;
  var
  fact:double;
  oldwidth,oldHeight:Integer;
  begin
      if Assigned(outputCanvas) then UnRegisterCanvas;

      oldwidth:=width;
      oldheight:=height;
  IF (wintabpidval<>1) or (ansilowercase(copy(globPadType,1,6))<>'wintab') then
      begin
      fact:=(width/height);
      If fact<1.725490196 then
         begin
         height:=round(width/1.725490196);
         yoffs:=yoffs+((oldheight-height) div 2);
         end
         else
         begin
         width:=round(height*1.725490196);
         xoffs:=xoffs+((oldwidth-width) div 2);
         end;
        end;    
      firsttime := true;

      xoffset := xoffs;
      yoffset := yoffs;
      desiredwidth := width;
      desiredheight := height;
      outputCanvas := canvas;

      w.RegisterCanvas(canvas);
  end;


  procedure MoveTo(x1,y1 : single);
  begin
      xpos:=x1;
      ypos:=y1;
  end;


  procedure AALine(x2,y2 : single; z:byte; color : tcolor; canvas : tcanvas);

  function CrossFadeColor(FromColor,ToColor : TColor; Rate : Single) : TColor;
  var r,g,b : byte;
  begin
      Rate:=Rate*(0.25 + 0.5*(z-35)/(128-35));
      r:=Round(GetRValue(FromColor)*Rate+GetRValue(ToColor)*(1-Rate));
      g:=Round(GetGValue(FromColor)*Rate+GetGValue(ToColor)*(1-Rate));
      b:=Round(GetBValue(FromColor)*Rate+GetBValue(ToColor)*(1-Rate));
      Result:=RGB(r,g,b);
  end;


  procedure pixel(x : single; y : single);
  var FadeRate : single;
      xi, yi : Integer;
  begin
      xi:=trunc(x);
      yi:=trunc(y);
      with canvas do
      begin
          FadeRate:=0.5*(y-trunc(y)+ x-trunc(x));
          pixels[xi,yi]:=CrossFadeColor(Color,Pixels[xi,yi],1-FadeRate);
          pixels[xi+1,yi+1]:=CrossFadeColor(Color,Pixels[xi+1,yi+1],FadeRate);

          FadeRate:=0.5*(1+y-trunc(y)-x+trunc(x));
          pixels[xi,yi+1]:=CrossFadeColor(Color,Pixels[xi,yi+1],FadeRate);
          pixels[xi+1,yi]:=CrossFadeColor(Color,Pixels[xi+1,yi],1-FadeRate);
      end;
  end;

  var i : integer;
      currentx,currenty,deltax,deltay,l,x1,y1 : single;
  begin

      tcs.Acquire;

      x1:=xpos;
      y1:=ypos;
      l:=(x2-x1)*(x2-x1) + (y2-y1)*(y2-y1);
      if l>1 then begin

          l:=Sqrt(l);

          currentx:=x1;
          currenty:=y1;

          deltax:=(x2-x1)/l;
          deltay:=(y2-y1)/l;

          for i:=1 to trunc(l) do
          begin
              currentx:=currentx+deltax;
              currenty:=currenty+deltay;
              pixel(currentx, currenty);
              pixel(currentx+0.5, currenty-0.5);
              //canvas.Pixels[trunc(currentx),trunc(currenty)]:=clBlack;
              {pixel(currentx+1, currenty+1);
              pixel(currentx-1, currenty-1);
              pixel(currentx-2, currenty-2);
              pixel(currentx+3, currenty+3);
              pixel(currentx+4, currenty+4);
              pixel(currentx+5, currenty+5);
              pixel(currentx+6, currenty+6);
              pixel(currentx+7, currenty+7);

              Canvas.Pixels[trunc(currentx), trunc(currenty)]:=clBlack;
              Canvas.Pixels[trunc(currentx)+1, trunc(currenty)+1]:=clBlack;
              Canvas.Pixels[trunc(currentx)-1, trunc(currenty)-1]:=clBlack; }
          end;

          xpos := x2;
          ypos := y2;

      end;

      tcs.Release;

  end;


  //===================================================
  procedure CPReceiveCallBack( Data: string );
  var i, k, j : integer;
      xcoord, ycoord, framenumber : SmallInt;
      zcoord, linenumber : byte;
      d, c, upperbyte : byte;
      secretkey : string;
      x, y : single;
      //frame : tDataFrame;
      temp_outputcanvas : TCanvas;
      ReadTime:Boolean;

  begin
  Readtime:=true;
      if BufferAll then
      begin

          DataBuffer := Concat(DataBuffer, Data);
          Data := '';

          {
          if containsstr(DataBuffer, 'ePad') then
          begin
              PadType := 'ePad';
              BufferAll := false;
          end;
          }

          if containsstr(DataBuffer, '+PadBT') then
          begin
              globPadType := '+Pad BT';
              BufferAll := false;
          end;


          if containsstr(DataBuffer, '+PadUSB') then
          begin
              globPadType := '+Pad USB';
              BufferAll := false;
          end;


          if containsstr(DataBuffer, '+PadS') then
          begin
              globPadType := '+Pad SP';
              BufferAll := false;
          end;

          // BluePads don't send any Pad-Type-Identifier,
          // that's how we recognize them
          if BufferAll = false then
          begin
              ReceivedPadType.SetEvent;
          end;

          if length(DataBuffer) > 100 then BufferAll := false;
      end;

      if not BufferAll then
      begin
          Data := DataBuffer + Data; // put buffered stuff in front
          DataBuffer := '';

          temp_outputcanvas := outputcanvas;
          if temp_outputcanvas <> nil then temp_outputcanvas.lock;

          for i:=1 to length(data) do
          begin

              if i+11 >= length(data) then // buffer for next time
              begin
                  DataBuffer := DataBuffer + Data[i];
              end
              else
              begin // process data

                  if dd >= 12 then // another 12 bytes arrived?
                  begin
                      // check that it's not a data frame
                      // if not ((byte(data[i+2])>128) and (byte(data[i])=85) and (byte(data[i+1])=0)) then

                      // Well, 50 seems to be the indicator that an ID+GMT frame starts...
                      // Can't be sure though, since there was no official docu on this
                      if Readtime then
                      begin
                          // ok, should be an ID+GMT frame

                          d:=((byte(data[i+2]) + byte(data[i+3])
                          + byte(data[i+4]) + byte(data[i+5])
                          + byte(data[i+6]) + byte(data[i+7])
                          + byte(data[i+8]) + byte(data[i+9])
                          + byte(data[i+10]) )and 127);

                          c:=byte(data[i+11]);

                          if (c=d) then // checksum ok?
                          begin

                              Readtime:=false;
                              If (ansilowercase(copy(globpadType,1,4)) ='+pad') or (ansilowercase(copy(globpadType,1,4)) ='le p')  then
                                for j:=1 to 5 do
                                  BioData.PID[j] := byte(data[i+j-1]);

                              // isLE - is Light Edition, i.e. without real time clock

                              // according to Bernhard
                              if (byte(data[i+5]) = $7F) and
                                 (byte(data[i+6]) = $7F) and
                                 (byte(data[i+7]) = $7F) and
                                 (byte(data[i+8]) = $7F) and
                                 (byte(data[i+9]) = $7F) and
                                 (byte(data[i+10]) = $7F)
                              then
                              begin
                                  isLE := true;
                              end
                              else
                              begin
                                  isLE := False;
                                  with BioData.GMTStamp do
                                  begin
                                  If ansilowercase(copy(globpadType,1,4)) ='+pad' then
                                      begin
                                      seconds := ((byte(data[i+5]) and $70) shr 4) * 10 + byte(data[i+5]) and $0F;
                                      minutes := ((byte(data[i+6]) and $70) shr 4) * 10 + byte(data[i+6]) and $0F;
                                      hours := ((byte(data[i+7]) and $30) shr 4) * 10 + byte(data[i+7]) and $0F;
                                      days := ((byte(data[i+8]) and $30) shr 4) * 10 + byte(data[i+8]) and $0F;
                                      months := ((byte(data[i+9]) and $10) shr 4) * 10 + byte(data[i+9]) and $0F;
                                      years := ((byte(data[i+10]) and $F0) shr 4) * 10 + byte(data[i+10]) and $0F;
                                      end
                                      else
                                      begin
                                      seconds := 0;
                                      minutes := 0;
                                      hours := 0;
                                      days := 0;
                                      months := 0;
                                      years := 0;
                                      end;
                                  end;
                              end;
                          end;

                      end;

                      dd:=0;

                  end;

                  dd:=dd+1;

                  // check if the data frame head is correct
                  if (byte(data[i+2])>128) and (byte(data[i])=85) and (byte(data[i+1])=0) and ((byte(data[i+2])and 4)=4)then // Header ermitteln.
                  begin
                      dd:=1;

                      inc(numallframes);

                      if (byte(data[i+2]) = 204) then
                      begin
                          // process firmware frame
                          // - just ignore it, for now

                          // signal ReceivedPadType, so bluePads
                          // are recognized
                          ReceivedPadType.SetEvent;
                      end
                      else
                      if ((byte(data[i+2]) and 254) = 198) or   // sollte c6/c7 (198/199) sein
                          ((byte(data[i+2]) and 254) = 238) then // nicht dokumentiert:238/239 = ID Number Packet (niederwertigstes Bit = Batterie Status)
                      begin
                          // process PID frame
                          secretkey := 'NEURO';
                          for k := 1 to 5 do
                                  PID[k] := (byte(data[i+2 + k]) xor byte(secretkey[k]));
                          PIDValid := true;

                          BioData.PID := PID;

                          ReceivedPID.SetEvent;
                      end
                      else
                      begin

                          // decrypt
                          for k := 1 to 5 do
                              data[i + 2 + k] := char(byte(data[i + 2 + k]) xor PID[k]);

                          d:=((byte(data[i+2]) + byte(data[i+3])
                              + byte(data[i+4]) + byte(data[i+5])
                              + byte(data[i+6]) + byte(data[i+7])
                              + byte(data[i+8]) + byte(data[i+9])
                              + byte(data[i+10]) )and 127);

                          c:=byte(data[i+11]);

                          // checksum ok?
                          If (c=d) then
                          begin
                              inc(numgoodframes);


                              ////////////// Framenummer auslesen /////////////////////////////

                              // Die 7 Lower und 7 upper Bits in eine Integer speichern.
                              framenumber:=(byte(data[i+8]) + (byte(data[i+9])shl 7));


                              ////////////// Linenumber auslesen /////////////////////////////

                              linenumber:=byte(data[i+10]);


                              ////////////// X-Koordinaten ermitteln /////////////////////////

                              // Das Vorzeichehnbit im Upperbyte Lschen
                              upperbyte:= (byte(data[i+4]) and (15));

                              // Die 7 Lower und 5 upper Bits in eine Integer speichern.
                              xcoord:=(byte(data[i+3]) + (upperbyte shl 7));

                              // Wenn das upperbyte Vorzeichenbehftet war, dann 2048 addieren, damit wird der Nullpunkt von der Mitte des Sensors in die Ecke verlegt.
                              if (byte(data[i+4]) and 16) = 0 then
                                  xcoord := xcoord + 2048;

                              // Denn Nullpunkt von rechts nach links invertieren.
                              xcoord:=-(xcoord-4096);


                              ///////////// Y-Koordinaten ermitteln //////////////////////////

                              // Das Vorzeichehnbit im Upperbyte Lschen
                              upperbyte:=(byte(data[i+6])and (15));

                              // Die 7 Lower und 5 upper Bits in eine Integer speichern.
                              ycoord:=(byte(data[i+5]) + (upperbyte shl 7));

                              // Wenn das Upperbyte Vorzeichenbehftet war, dann 2048 addieren, damit wird der Nullpunkt von der Mitte des Sensors in die Ecke verlegt.
                              if (byte(data[i+6]) and 16)=0 then
                                  ycoord:=ycoord+2048;

                              // Den Nullpunkt von unten nach oben invertieren.
                              ycoord:=-(ycoord-4096);


                              /////////////// Z-Koordinaten /////////////////////////////////

                              zcoord := byte(data[i+7]);

                              
                              If FirstRead then   // Set defaults
                                begin
                                FirstRead:=False;
                                findex:=0;
                                ftime:=0;
                                fnowOld:=GetTickCount;
                                Lold:=linenumber;
                                FNold:=Framenumber;
                                FN:=fnOld;
                                end;
                              If linenumber<>Lold then
                                begin
                                ftime:=ftime+(gettickcount-fnowold);
                                lold:=lineNumber;
                                end;
                              if framenumber<FNold then
                                 fn:=fn+(-16383);
                              setlength(BioData.Frames,length(BioData.Frames)+1);
                              BioData.Frames[length(biodata.frames)-1].x := xcoord;
                              BioData.Frames[length(biodata.frames)-1].y := ycoord;
                              BioData.Frames[length(biodata.frames)-1].z := zcoord;
                              BioData.Frames[length(biodata.frames)-1].FrameNumber :=framenumber-fn;
                              BioData.Frames[length(biodata.frames)-1].LineNumber:= linenumber;
                              BioData.Frames[length(biodata.frames)-1].timeCode:=ftime+(trunc((FrameNumber-FN)*2.69));
                              fnowOld:=GetTickCount;
                              fnold:=framenumber;
                              If (linenumber <> oldlinenumber) then
                                begin
                                ReadTime:=True;
                                end;

                              if temp_outputcanvas <> nil then
                              begin

                                  x := xoffset + (xcoord - xmin) * desiredwidth / (xmax - xmin);
                                  y := yoffset + (ycoord - ymin) * desiredheight / (ymax - ymin);

                                  If (linenumber <> oldlinenumber) or firsttime then
                                  begin
                                      firsttime := false;
                                      oldlinenumber := linenumber;
                                      moveto(x,y);
                                  end;

                                  AALine(x, y, zcoord, $00000000 , temp_outputcanvas);
                              end;

                          end else
                          begin

                              // Prfsumme  war  falsch
                              {
                              strzz:='';
                              for zz:=i to (i+11) do
                              begin
                                  if (byte(Data[zz]))<100 then
                                      strzz:=strzz+'0';
                                  if (byte(Data[zz]))<10 then
                                      strzz:=strzz+'0';
                                  strzz:=strzz+inttostr(byte(Data[zz]))+'|';
                              end;
                              }

                          end;
                      end;
                  end;
              end;
          end;

          if temp_outputcanvas <> nil then temp_outputcanvas.Unlock;
      end;
  end;



  procedure VaComm1RxCharP(Sender: TObject; Count: Integer);
  var s : String;
  begin
      s := VaComm1.ReadText;
    //  Application.MessageBox(s);
      CPReceiveCallBack(s);
  end;

  procedure Wrapper.VaComm1RxChar(Sender: TObject; Count: Integer);
  begin
      VaComm1RxCharP(Sender, Count);
  end;


  function getPadSettings(oldSettings,CertStr:shortstring):shortstring;
  begin
  globCert:=Certstr;
  altsettings:=oldSettings;
  SOConfigform:=TSOConfigForm.Create(nil);
  SOConfigForm.Showmodal;
  result:=newSettings;
  end;

  procedure setPadSettings(PadSettings,CertStr:shortstring);
  var
  str:string;
  begin
  globCert:=CertStr;
  globAuto:=true;
  globPID[1]:=strtoint(PadSettings[1]+PadSettings[2]+PadSettings[3]);
  globPID[2]:=strtoint(PadSettings[4]+PadSettings[5]+PadSettings[6]);
  globPID[3]:=strtoint(PadSettings[7]+PadSettings[8]+PadSettings[9]);
  globPID[4]:=strtoint(PadSettings[10]+PadSettings[11]+PadSettings[12]);
  globPID[5]:=strtoint(PadSettings[13]+PadSettings[14]+PadSettings[15]);
  SetCom(strtoint(PadSettings[16]+PadSettings[17]+PadSettings[18]));
  str:=Padsettings;
  SetPadType(copy(str,19,length(str)-17));
  end;

  procedure Wrapper.ComPort1ReceiveCallBack( Data: string );
  begin
      CPReceiveCallBack(Data);
  end;


  constructor Wrapper.Create(AOwner: TComponent);
  begin
      inherited Create(nil);


      VaComm1 := TVaComm.Create(Self);

      //VaComm1 := tcct.TVa;
      VaComm1.Baudrate := br115200;
      VaComm1.Databits := db8;
      //VaComm1.FlowControl := fcNone;
      VaComm1.Parity := paNone;
      VaComm1.Stopbits := sb1;

      //VaComm1.SyncEvents := seByMessage;

      VaComm1.OnRxChar := Self.VaComm1RxChar;

      Comport1 := TComport.Create(nil);

      Comport1.ReceiveCallBack := Self.ComPort1ReceiveCallBack;
      Comport1.ReceiveMode := rmRAW;
      comport1.StopBits:= sbone;
      comport1.Parity := ptnone;
      Comport1.Baud := 115200;

      UpdateManager := TUpdateManager.Create;
  end;

  function getBioDataString:Pchar;
  var
  str:string;
 { widestr:widestring;  }
  PID:PIDType;
  GMT:GMTStampType;
  Fnum,i:integer;
  DataFr:tFrames;
  bdata:pchar;
  begin
  str:='';
  getbiodata(PID,gmt,Fnum,DataFr);
  for i:=0 to length(DataFr)-1 do
        begin
        str:=str+pchar('x' + inttostr(dataFr[i].x) + 'y' +
        inttostr(dataFr[i].y)+'z' + inttostr(dataFr[i].z) + 'f' +
        inttostr(dataFr[i].FrameNumber)+'l' + inttostr(dataFr[i].LineNumber)+ 't' +
        inttostr(dataFr[i].timecode));
        end;
 { Str:='Hello World';
  Str:=ZLibEx.ZCompressStr(Str,zcMax);
  widestr:=str;
  Str:=ZLibEx.ZDecompressStr(wideStr); }
  str:=Str+('p'+inttostr(pid[1]) + '-' +inttostr(pid[2]) + '-' +inttostr(pid[3])
          + '-' +inttostr(pid[4]) + '-' +inttostr(pid[5]));
  str:=Str+('g'+inttostr(gmt.hours)+':'+inttostr(gmt.minutes)+':'+inttostr(gmt.seconds)
          +' '+ inttostr(gmt.days)+'.'+inttostr(gmt.months)+'.'+inttostr(gmt.years));

  end;

  procedure DeCompBioDataString(Biodata:Pchar);
  var
  str:string;
  begin
 { Str:=Biodata;
  Str:=ZLibEx.ZDecompressStr(Str);
  BioData:=Pchar(Str);  }
  end;

  procedure setlang(lang:shortstring);
  begin
  If (Ansilowercase(lang)<>'gb') and (Ansilowercase(lang)<>'d')and
  (Ansilowercase(lang)<>'pl') and (Ansilowercase(lang)<>'es') then
        lang:='gb';
  globLanguage:=Lang;
  IF Ansilowercase(lang)='gb' then
        begin
        CerApp:='The certified application:';
        ReqID:='requires the ID of your signature pad.';
        fiveSec:='Please press the button on the left side of your pad for 5 seconds until a confirmation is displayed.';
        PadIDstr:='Pad Identification';
        Pwait:='please wait...';
        Warni:='Please press cancel if you are not sure if you can trust this application!';
        warning1:='WARNING:';
        uncert:='an uncertified application';
        tryuse:='tries to use your signature pad.';
        congrad1:='Congratulations';
        congrad2:='Your Pad ID has been transmitted successfully!';
        globWintabDevice:='Wintab device';
        wintaboption:='Other (e.g. Wacom)';
        globCheckpad:='Check Pad';
        globTest:='Test pad';
        gobStop:='Stop';
        globOK:='OK';
        globCancel:='Cancel';
        globactualPad:='Actual signature pad settings:';
        globAutosearch:='&Start automatic pad search >>';
        globAutosearch2:='&Search for more pads >>';
        globMansearch:='&Manual pad configuration';
        globnopad:='No pad';
        globpadfound:='Press Ok to save'+#13+'the settings of this pad.';
        globnomorepad:='No more signature Pads has been found! Press OK'+#13+'to save the settings of the last pad that has been found.';
        globnopadfound:='No signature pad has been found!';
        globnopadatall:='No signature pad has been found! Please close the driver window,'+#13+'and make sure that your pad is connected. Afterwards please try again!';
        end;
  IF Ansilowercase(lang)='d' then
        begin
        CerApp:='Die zertifizierte Anwendung:';
        ReqID:='bentigt die ID Ihres Signatur-Pads.';
        fiveSec:='Bitte drcken Sie den Knopf auf der linken Seite Ihres Pads fr 5 Sekunden, bis eine Besttigung erscheint.';
        PadIDstr:='Pad-Identifikation';
        Warni:='Drcken Sie Abbrechen, wenn Sie sich ber die Anwendung nicht sicher sind!';
        warning1:='WARNUNG:';
        uncert:='eine unzertifizierte Anwendung';
        tryuse:='versucht auf Ihr Signatur-Pad zu zugreifen.';
        congrad1:='Gratulation !';
        congrad2:='Ihre Pad-ID wurde erfolgreich bertragen.';
        Pwait:='Bitte warten...';
        globWintabDevice:='Wintab Gert';
        wintaboption:='Anderes Gert (z.B. Wacom)';
        globCheckpad:='Pad berprfen';
        globTest:='Pad testen';
        gobStop:='Stop';
        globOK:='OK';
        globCancel:='Abbrechen';
        globactualPad:='Aktuell eingestelltes Signatur-Pad:';
        globAutosearch:='&Start der automatischen Pad-Suche >>';
        globAutosearch2:='&Nach weiteren Pads suchen >>';
        globMansearch:='&Manuelle Pad-Konfiguration';
        globnopad:='Kein Signatur-Pad';
        globpadfound:='Drcken Sie OK um die'+#13+'Einstellungen fr dieses Signatur-Pad zu speichern.';
        globnomorepad:='Kein weiters Signatur-Pad gefunden!'+#13+'Drcken Sie OK um das zuletzt gefundene Pad zu speichern.';
        globnopadfound:='Kein Signatur-Pad gefunden.';
        globnopadatall:='Kein Signatur-Pad gefunden! Bitte schlieen Sie das Treiberfenster,'+#13+'stellen Sie sicher, dass Ihr Pad angeschlossen ist und versuchen Sie es erneut!';
        end;
    IF Ansilowercase(lang)='pl' then
        begin
        CerApp:='Certyfikowana aplikacja:';
        ReqID:='wymagane ID instalowanego tabletu.';
        fiveSec:='Prosze nacisnac przycisk po lewej stronie przez 5 sec. do uzyskania potwierdzenia.';
        PadIDstr:='Identyfikacja tabletu';
        Warni:='Prosze przycisnac "Anuluj" jezeli nie sa Panstwo pewni oryginalnosci programu!';
        warning1:='OSTRZEZENIE:';
        uncert:='niecertyfikowana aplikacja';
        tryuse:='probuje uzyc panskiego tabletu.';
        congrad1:='Gratulacje';
        congrad2:='Numer ID tabletu jest poprawny!';
        Pwait:='prosze czekac...';
        globWintabDevice:='Urzadzenie Wintab';
        wintaboption:='Inne (np. Wacom)';
        globCheckpad:='Sprawdz tablet';
        globTest:='Testuj tablet';
        gobStop:='Stop';
        globOK:='OK';
        globCancel:='Anuluj';
        globactualPad:='Actual signature pad settings:';
        globAutosearch:='&Start automatic pad search >>';
        globAutosearch2:='&Search for more pads >>';
        globMansearch:='&Manual pad configuration';
        globnopad:='No pad';
        globpadfound:='Press Ok to save'+#13+'the settings of this pad.';
        globnopadfound:='No signature pad has been found';
        globnopadatall:='No signature pad has been found! Please close the driver window,'+#13+'and make sure that your pad is connected. Afterwards please try again!';
        end;
    IF Ansilowercase(lang)='es' then
        begin
        CerApp:='Aplicacin certificada:';
        ReqID:='requiere el ID de su pad.';
        fiveSec:='Por favor, pulse el botn del lado izquierdo de su pad durante 5 segundos hasta que aparezca una seal.';
        PadIDstr:='Pad, identificacin';
        Warni:='Pulse cancelar en caso de que no confie en esta aplicacin!';
        warning1:='ATENCIN:';
        uncert:='Aplicacin no certificada,';
        congrad1:='Enhorabuena!';
        congrad2:='El ID del pad ha sido transmitido con exito!';
        tryuse:='tries to use your signature pad.';
        Pwait:='please wait...';
        globWintabDevice:='Wintab device';
        wintaboption:='Other (e.g. Wacom)';
        globOK:='OK';
        globCancel:='Cancel';
        globactualPad:='Actual signature pad settings:';
        globAutosearch:='&Start automatic pad search >>';
        globAutosearch2:='&Search for more pads >>';
        globMansearch:='&Manual pad configuration';
        globnopad:='No pad';
        globpadfound:='Press Ok to save'+#13+'the settings of this pad.';
        globnopadfound:='No signature pad has been found';
        globnopadatall:='No signature pad has been found! Please close the driver window,'+#13+'and make sure that your pad is connected. Afterwards please try again!';
        end;
  end;

function startWintab:string;
var
  AContext: TLogContext;
  ResX, ResY: TAxis;
begin
IF tabletclosed then
  begin
  IF not WintabActivation then
        begin
        result:='no pad';
        exit;
        end;
  Tablet1:=TTablet.Create(Nil);
  with Tablet1, AContext do
  begin
    if not Present then
    begin
      result:='no pad';
      Exit;
    end;
    IF wintabPidval>1 then
        begin
        globTablet:=False;
        end;
    { Fill context with defaults }
    DefaultContext(AContext);
    { Set option flags to initialize messaging }
    IF not (wintabPidval=1) then
  	Options := Options or lcOptions
        else
        Options := Options or lcTabletOptions;
    { Bitfields in PktData indicates what data to receive in packets }
  	PktData := lcPktData;
    { Mask buttons (optional) }
    BtnDnMask := lcBtnMask;
    BtnUpMask := BtnDnMask;
    MsgBase := WT_DEFBASE;
    { This will allocate memory for the packets }
    PacketSize := SizeOf(TMyPacket);
    { Open the context and get handle }
    Enabled := True;
    Open(AContext);
  end;
  WTInfo(WTI_DEVICES, DVC_X, @ResX);
  WTInfo(WTI_DEVICES, DVC_Y, @ResY);
  tabletxres:=Resx.Max;
  tabletyres:=Resy.Max;
  tabletminX:=Resx.Min;
  tabletminY:=ResY.Min;
  tabletpcxres:=tabletxres;
  tabletpcyres:=tabletyres;
  tabletMaximumX:=Resx.Max;
  tabletMaximumY:=Resy.Max;

  IF (wintabPidval=1) then
     setWintabTabletPCRegion(OTabletX1,OTablety1,OTabletX2,OTabletY2);
  IF wintabPidval=2 then
        tabletsamplerate:=100
        else
        tabletsamplerate:=tablet1.PacketRate;
  result:=Tablet1.DeviceName;
  Tablet1.OnPacket:=w2.Tablet1Packet;
  tabletclosed:=False;
  end;
end;

procedure closeWintab;
begin
IF not tabletclosed then
        begin
        Tablet1.Enabled:=False;
        Tablet1.OnPacket:=NIL;
        Tablet1.Free;
        tabletclosed:=True;
        end;
end;


constructor Wrapper2.Create(AOwner: TComponent);
begin
inherited Create(nil);
//Tablet1:=TTablet.Create(Nil);
//Tablet1.OnPacket:=self.Tablet1Packet;
end;

Procedure Wrapper2.Tablet1Packet(Sender: TObject; PacketNumber, ContextHandle: HCtx;pPacket: Pointer);
var
temp_outputcanvas:TCanvas;
xcoord, ycoord : smallint;
zcoord : byte;
x, y : single;
ytablettd,tabletxfact,tabletyfact:double;
xsavecoord:Integer;
begin
With biodata do
             begin
             PID[1]:=wintabPidval;
             PID[2]:=wintabPidval;
             PID[3]:=wintabPidval;
             PID[4]:=wintabPidval;
             PID[5]:=wintabPidval;
             end;
temp_outputcanvas := outputcanvas;
if temp_outputcanvas <> nil then
        temp_outputcanvas.lock;
IF Firstread then
        begin
        Firstread:=False;
        with BioData.GMTStamp do   // Wintab is not supporting internal clock messages from the pad
                begin
                TabletReadTime:=False;
                seconds := 0;
                minutes := 0;
                hours := 0;
                days := 0;
                months := 0;
                years := 0;
                end;
        IF (tabletsamplerate>0) and (tabletsamplerate<=1000) then   // If we can use the given sample rate
                begin
                tabletmsec:=trunc(1000/tabletsamplerate);
                tablettimego:=True; //Use Pad samplerate for time reporting
                end
                else
                tablettimego:=False; // always use gettickcount (systemtime) for timereport
        tablettime:=gettickcount;
        TabletFramenumber:=0;
        TabletLineNumber:=1;
        Tabletoldlinenumber:=0;
        factX:=xmax/tabletXres;  // scale padsensor to fit stepover pad sensors
        IF (wintabPidval=3) or (wintabPidval=1) then
                ytablettd:=tabletYres*0.83333333333
                else
                ytablettd:=tabletYres;
        factY:=ymax/ytablettd;
        IF (wintabPidval=3) then
                begin
                factX:=factX*0.83333333333;
                factY:=factY*0.83333333333;
                end;
        IF (tablet1.Pressure.Max>255) then
            factZ:=255/tablet1.Pressure.Max
            else
            factZ:=1;
        xmin:=0;
        ymin:=0;
        IF (wintabPidval=1) then
                begin
                setlength(BioData.Frames,length(BioData.Frames)+1);
                BioData.Frames[length(biodata.frames)-1].x := xmax;
                BioData.Frames[length(biodata.frames)-1].y := ymax;
                BioData.Frames[length(biodata.frames)-1].z := 0;
                BioData.Frames[length(biodata.frames)-1].FrameNumber:=0;
                BioData.Frames[length(biodata.frames)-1].LineNumber:= 0;
                BioData.Frames[length(biodata.frames)-1].timeCode:=0;
                end;
        OldXMax:=xmax;
        OldYMax:=ymax;
        end
        else
        begin
        //
        end;
with TMyPacket(pPacket^) do
  begin
  IF TabletTurned then
        begin
        xsavecoord:=Coords.y;
        Coords.Y:=abs(coords.X - tabletpcxres);
        coords.X:=abs(xsavecoord - tabletpcyres);
        end;

  IF (((Pressure>0) or (Buttons=1)) and ((wintabPidval=3)or(wintabPidval=2))) or
     (((Pressure>0) or (Buttons=1)) and ((wintabPidval=1) and (Coords.X>TabletX1)
     and (abs(Coords.Y - tabletpcyres)>TabletY1) and (Coords.X<TabletX2) and
     (abs(Coords.Y - tabletpcyres)<TabletY2)))or (TabletTurned and ((Pressure>0)
     or (Buttons=1)) and (Coords.X>TabletX1)and (Coords.X<TabletX2) and
     (Coords.Y>Tablety1)and (Coords.y<Tablety2))then
        begin
        TabletReadtime:=True;
        inc(TabletFramenumber);
        end
        else
        begin
        IF TabletReadtime then
                inc(TabletLineNumber);
        TabletReadtime:=False;
        end;
  IF TabletReadtime then
        begin
        IF (not tabletturned) and ((Coords.X>tabletpcxres) or (Coords.Y>tabletpcyres)) then
                exit;
        xcoord:=Coords.X;
        if (not tabletturned) then
                ycoord:=abs(Coords.Y - tabletpcyres)
                else
                ycoord:=Coords.Y;
        Xcoord:=trunc(Xcoord*factX);
        Ycoord:=trunc(Ycoord*factY);
        IF trunc(Pressure*factZ)>255 then
           zcoord:=255
           else
           zcoord:=trunc(Pressure*factZ);
        if tablet1.Pressure.Max=0 then
                zcoord:=255;
        if (wintabPidval=1) then
            begin
            Xoffset:=0;
            yoffset:=0;
            xcoord:=xcoord-trunc(TabletX1*factX);
            ycoord:=ycoord-trunc(TabletY1*factY);
            tabletxfact:=xmax/((TabletX2-TabletX1)*(factX));
            tabletyfact:=ymax/((Tablety2-Tablety1)*(factY));
            Xcoord:=trunc(Xcoord*tabletxfact);
            Ycoord:=trunc(Ycoord*tabletyfact); 
            end;
        IF (wintabPidval=1) and ( (OldXMax<>xmax) or (OldYMax<>ymax) ) then
                begin
                inc(TabletFramenumber);
                setlength(BioData.Frames,length(BioData.Frames)+1);
                BioData.Frames[length(biodata.frames)-1].x := xmax;
                BioData.Frames[length(biodata.frames)-1].y := ymax;
                BioData.Frames[length(biodata.frames)-1].z := 0;
                BioData.Frames[length(biodata.frames)-1].FrameNumber:=TabletFramenumber;
                BioData.Frames[length(biodata.frames)-1].LineNumber:= 0;
                IF (length(BioData.Frames)>2) then
                        BioData.Frames[length(biodata.frames)-1].timeCode:=BioData.Frames[length(biodata.frames)-2].timeCode
                        else
                        BioData.Frames[length(biodata.frames)-1].timeCode:=0;
                OldXMax:=xmax;
                OldYMax:=ymax;
                end;
        setlength(BioData.Frames,length(BioData.Frames)+1);
        BioData.Frames[length(biodata.frames)-1].x := xcoord;
        BioData.Frames[length(biodata.frames)-1].y := ycoord;
        BioData.Frames[length(biodata.frames)-1].z := zcoord;
        BioData.Frames[length(biodata.frames)-1].FrameNumber:=TabletFramenumber;
        BioData.Frames[length(biodata.frames)-1].LineNumber:= Tabletlinenumber;
        If tablettimego and (length(BioData.Frames)>2) and (Tabletlinenumber = Tabletoldlinenumber){and (BioData.Frames[length(biodata.frames)-2].timeCode>=gettickcount-tablettime) }then
                begin
                BioData.Frames[length(biodata.frames)-1].timeCode:=BioData.Frames[length(biodata.frames)-2].timeCode+Tabletmsec;
                end
                else
                BioData.Frames[length(biodata.frames)-1].timeCode:=gettickcount-tablettime;
        if (temp_outputcanvas <> nil) then
                              begin
                                  x := xoffset + (xcoord - xmin) * desiredwidth / (xmax - xmin);
                                  y := yoffset + (ycoord - ymin) * desiredheight / (ymax - ymin);

                                  If (Tabletlinenumber <> Tabletoldlinenumber)then
                                  begin
                                      Tabletoldlinenumber := Tabletlinenumber;
                                      moveto(x,y);
                                  end;
                                  IF zcoord>127 then
                                        zcoord:=127;
                                  AALine(x, y, zcoord, $00000000 , temp_outputcanvas);
                              end;
        end;
  end;
if temp_outputcanvas <> nil then
        temp_outputcanvas.Unlock;
end;

Procedure useWintabDevices(TabletPC,ExternalDevices:Boolean);
begin
UseWintab:=ExternalDevices;
UseWintabTablet:=TabletPC;
end;

Procedure setWintabCorpLic(corpLic:shortstring);
begin
globCorpCode:=corpLic;
end;

Procedure setWintabTabletPCRegion(x1,y1,x2,y2:Integer);
begin
TabletX1:=X1;
TabletY1:=Y1;
TabletX2:=X2;
TabletY2:=Y2;
OTabletX1:=X1;
OTabletY1:=Y1;
OTabletX2:=X2;
OTabletY2:=Y2;
IF not tabletturned then
   begin
   IF (tabletMaximumX>0) and (tabletMaximumY>0) and (wintabpidval=1) and
   (ansilowercase(copy(globPadType,1,6))='wintab') then
        begin
        tabletPCDivX:=tabletMaximumX/GetSystemMetrics(SM_CXSCREEN);
        tabletPCDivY:=tabletMaximumY/GetSystemMetrics(SM_CYSCREEN);
        TabletX1:=trunc(tabletX1*tabletPCDivX);
        TabletY1:=trunc(tabletY1*tabletPCDivY);
        TabletX2:=trunc(tabletX2*tabletPCDivX);
        TabletY2:=trunc(tabletY2*tabletPCDivY);
        XMax:=TabletX2;
        yMax:=TabletY2;
        tabletXres:=Xmax;
        tabletYRes:=ymax;
        end;
   end
   else
   begin
   IF (tabletMaximumX>0) and (tabletMaximumY>0) and (wintabpidval=1) and
   (ansilowercase(copy(globPadType,1,6))='wintab')then
        begin
        tabletPCDivX:=tabletMaximumX/GetSystemMetrics(SM_CYSCREEN);
        tabletPCDivY:=tabletMaximumY/GetSystemMetrics(SM_CXSCREEN);
        TabletX1:=trunc(tabletX1*tabletPCDivX);
        TabletY1:=trunc(tabletY1*tabletPCDivY);
        TabletX2:=trunc(tabletX2*tabletPCDivX);
        TabletY2:=trunc(tabletY2*tabletPCDivY);
        XMax:=TabletX2;
        yMax:=TabletY2;
        tabletXres:=Xmax;
        tabletYRes:=ymax;
        end;
   end;
end;

function startCapture(Certificate:shortstring):Boolean;
begin
//
end;

function configurePad(Certificate:shortstring):Boolean;
begin
//
end;

function tabletTurned:boolean;
begin
result:=GetSystemMetrics(SM_CXSCREEN)<GetSystemMetrics(SM_CySCREEN);
end;

begin
    tabletclosed:=True;
    globTablet:=True;
    globCert:='';
    globauto:=False;
    tcs := TCriticalSection.Create;
    w := Wrapper.Create(nil);
    w2 := Wrapper2.Create(nil);
    setLang('gb');
    UseWintab:=False;
    UseWintabTablet:=False;
    globWintabCorpLic:='';
    TabletX1:=0;
    TabletY1:=0;
    TabletX2:=0;
    TabletY2:=0;
    globcorpcode:='';
    globprodnum:='';
    globlicence:='';
    end.
